Package org.eclipse.jgit.internal.storage.dfs

## Enum DfsObjDatabase.PackSource

- java.lang.Object
- - java.lang.Enum<DfsObjDatabase.PackSource>
  - - org.eclipse.jgit.internal.storage.dfs.DfsObjDatabase.PackSource

All Implemented Interfaces:
  `Serializable`, `Comparable<DfsObjDatabase.PackSource>`

Enclosing class:
  DfsObjDatabase

    public static enum DfsObjDatabase.PackSource
    extends Enum<DfsObjDatabase.PackSource>

Sources for a pack file.

### Enum Constant Summary

Enum Constants
`COMPACT` The pack was created by compacting multiple packs together.
`GC` Pack was created by Git garbage collection by this implementation.
`INSERT` The pack is created by ObjectInserter due to local activity.
`RECEIVE` The pack is created by PackParser due to a network event.
`UNREACHABLE_GARBAGE` Pack was created by Git garbage collection.

### Method Summary

All Methods Static Methods Concrete Methods
`static DfsObjDatabase.PackSource` `valueOf​(String name)` Returns the enum constant of this type with the specified name.
`static DfsObjDatabase.PackSource[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### INSERT

    public static final DfsObjDatabase.PackSource INSERT

The pack is created by ObjectInserter due to local activity.

#### RECEIVE

    public static final DfsObjDatabase.PackSource RECEIVE

The pack is created by PackParser due to a network event.

A received pack can be from either a push into the repository, or a fetch into the repository, the direction doesn't matter. A received pack was built by the remote Git implementation and may not match the storage layout preferred by this version. Received packs are likely to be either compacted or garbage collected in the future.

#### GC

    public static final DfsObjDatabase.PackSource GC

Pack was created by Git garbage collection by this implementation.

This source is only used by the `DfsGarbageCollector` when it builds a pack file by traversing the object graph and copying all reachable objects into a new pack stream.

See Also:
  `DfsGarbageCollector`

#### COMPACT

    public static final DfsObjDatabase.PackSource COMPACT

The pack was created by compacting multiple packs together.

Packs created by compacting multiple packs together aren't nearly as efficient as a fully garbage collected repository, but may save disk space by reducing redundant copies of base objects.

See Also:
  `DfsPackCompactor`

#### UNREACHABLE_GARBAGE

    public static final DfsObjDatabase.PackSource UNREACHABLE_GARBAGE

Pack was created by Git garbage collection.

This pack contains only unreachable garbage that was found during the last GC pass. It is retained in a new pack until it is safe to prune these objects from the repository.

### Method Detail

#### values

    public static DfsObjDatabase.PackSource[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (DfsObjDatabase.PackSource c : DfsObjDatabase.PackSource.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static DfsObjDatabase.PackSource valueOf​(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null